
%{
#include <stdio.h>
#include <string.h>

#define YYERROR_VERBOSE 1

extern int line_number;

%}

%union {
  char *stringa;
  int numero;
}

%token <numero> Program If Then Else Begin End Read Write While Do OP ASSOP Label Goto DuePunti Of Var For To Repeat Until SEQOP Punto ParAp ParCh Case 
%token <stringa> RELOP ARITOP NUM ID String
%type <stringa> inizio intestazione blocco dichiarazione parte_istruzioni istruzione sequenza_istruzioni ist_semplice ist_compl ciclo ist_condizionale ist_if ist_case Case_elem Case_rest test expression constant  

%start inizio

%%
inizio:
	intestazione blocco Punto 
	  { printf("%s",$1);
              printf("%s\n\nmain()\n{ %s ;}\n",$2,$1); }
	;

intestazione: Program ID SEQOP
          { sprintf($$,"%s()",$2);}
	;

blocco:  
      dichiarazione parte_istruzioni
      {
      sprintf($$,"%s\n%s",$1,$2); }
      |parte_istruzioni
      {sprintf($$,"%s",$1); }
      ;

dichiarazione:
	      Label ID SEQOP
	      {sprintf($$,"\n %s: ;",$2); }
	     |Var ID DuePunti ID SEQOP
	     {sprintf($$,"\n%s %s ;",$4,$2); }
	     
      ;

parte_istruzioni:
		Begin sequenza_istruzioni End
		{sprintf($$,"{\n%s\n }",$2); }
		;

sequenza_istruzioni:
		   istruzione SEQOP sequenza_istruzioni
		   { sprintf($$,"%s%s",$1,$2); }
		   |istruzione 
		   
		   ;

istruzione:
	  ist_semplice 
	  |ist_compl
	  ;

ist_semplice:
	   ID ASSOP  expression 
	    { sprintf($$,"%s=%s;\n",$1,$3);}
	   |Goto ID
	    { sprintf($$,"goto %s;\n",$2);}
	   |Read ID
	    { sprintf($$,"scanf(\"%%d\",&%s);\n",$2);  }
	   |Write ParAp expression ParCh
	    { sprintf($$,"printf(\"%%d\",%s);\n",$3); }
	    |Write ParAp String ParCh
	    { sprintf($$,"printf(%s);\n",$3); }

	    ;


ist_compl:
	 Begin sequenza_istruzioni End
	 { sprintf($$,"{%s}",$1); }
	 |ciclo
  	 |ist_condizionale 
         ;
ciclo:
       While expression Do istruzione
       { sprintf($$,"while (%s)\n%s",$2,$4); }
       |Repeat sequenza_istruzioni Until test
       { sprintf($$,"do {\n %s \n}\nwhile (%s) ;",$2,$4); }
       |For ID ASSOP expression To expression Do istruzione
       { sprintf($$,"for(%s=%s;%s=%s;%s++) {\n %s \n};\n",$2,$4,$2,$6,$2,$8); }
       ;

ist_condizionale:
	ist_if
	|ist_case
	{ sprintf($$,"%s",$1); }
	;

ist_if: 
     
	If test Then istruzione Else istruzione

        { sprintf($$,"if (%s)\n%selse\n%s",$2,$4,$6); }
	;

ist_case:
	Case expression Of Case_rest End SEQOP
	{ sprintf($$,"switch (%s) {\n%s\n}",$2,$4); }
	;
	
Case_elem: 
	constant DuePunti istruzione
	{ sprintf($$,"case '%s':%s\n",$1,$3);}
	;


Case_rest: Case_elem Case_rest
	{ sprintf($$,"%s%s",$1,$2); }
        |Case_elem
        ;
								 
       
	
	

test: expression RELOP expression 
        { if (strcmp($2,"=")==0)
	  sprintf($$,"%s==%s",$1,$3);
          else if (strcmp($2,"<>")==0)
                 sprintf($$,"%s!=%s",$1,$3);
               else sprintf($$,"%s%s%s",$1,$2,$3);
        }
    ;


expression: constant { strcpy($$,$1); }
          | constant ARITOP expression { sprintf($$,"%s%s%s",$1,$2,$3); } 
          ;

constant: NUM { strcpy($$,$1); }
          | ID { strcpy($$,$1); }
          ;

%% 


yyerror (char *s)  
{
  printf ("linea %d: %s\n", line_number, s);
}

main ()
{
/*
printf ("#include <stdio.h>\n"
	"#define integer int\n"
	"#define real double\n"
	);*/
  yyparse ();
}
